/******************************************************************************\
 *                        ____            _ _ 
 *                       |  _ \ ___ _ __ | (_) ___ __ _
 *                       | |_) / _ \ '_ \| | |/ __/ _` |
 *                       |  _ <  __/ |_) | | | (_| (_| |
 *                       |_| \_\___| .__/|_|_|\___\__,_|
 *                                 |_|
 ******************************************************************************
 *                                 
 *  Copyright (c) 2005-2006, Herbert Nachtnebel
 *                      
 ******************************************************************************
 *                      
 *  Title:    Replica - File Replication and Backup Utility
 *
 *  Version:  0.1
 *
 *  Date:     10-Dec-2005
 *
 *  Author:   Herbert Nachtnebel (Berri)
 *  
 ******************************************************************************
 *  
 *  Change log:
 *  
 *     Date     Rev  Ver                    Description
 *  ----------- --- ----- ---------------------------------------------------
 *  10-Dec-2005 Ber  0.1  Initial implementation
 *  
 ******************************************************************************
 *  
 *  Description:
 *
 *    All external settings are held in the configuration.
 *
 *    
\******************************************************************************/
#ifndef CONFIG_H_INCLUDED
#define CONFIG_H_INCLUDED

struct config
{
    char *nodename;                     /* name of this machine */
    char *codepage;                     /* the codepage this system uses */
    char *private;                      /* private data used by some algo's */
    
    char *dbase;                        /* absolute path to database */
    char *index;                        /* absolute path to index file */
    
    char **roots;                       /* dataset root paths */
    char **names;                       /* as well as their names */

    char **exclude;                     /* excluded files or directories */
    struct regexpr *filter;             /* regular expression for filtering */
};

#endif /* CONFIG_H_INCLUDED */
