/******************************************************************************\
 *                        ____            _ _ 
 *                       |  _ \ ___ _ __ | (_) ___ __ _
 *                       | |_) / _ \ '_ \| | |/ __/ _` |
 *                       |  _ <  __/ |_) | | | (_| (_| |
 *                       |_| \_\___| .__/|_|_|\___\__,_|
 *                                 |_|
 ******************************************************************************
 *                                 
 *  Copyright (c) 2005, Linus Torvalds
 *                      Herbert Nachtnebel
 *                      
 ******************************************************************************
 *                      
 *  Title:    Replica - File Replication and Backup Utility
 *
 *  Version:  0.1
 *
 *  Date:     01-Nov-2005
 *
 *  Author:   Herbert Nachtnebel (Berri)
 *  
 ******************************************************************************
 *  
 *  Change log:
 *  
 *     Date     Rev  Ver                    Description
 *  ----------- --- ----- ---------------------------------------------------
 *  01-Nov-2005 Ber  0.1  Initial implementation
 *  
 ******************************************************************************
 *  
 *  Description:
 *
 *    The Toolchest
 *    -------------
 *    
\******************************************************************************/
#ifndef UTILS_H_INCLUDED
#define UTILS_H_INCLUDED

/*
 *  That's handy.
 */
#define arrsize(array) (sizeof(array)/sizeof(array[0]))

/*
 *  Format the error message and exit.
 */
void die (const char *msg, ...) __attribute__((format(printf,1,2), noreturn));

/*
 *  Format an informal message and return.
 */
void info (const char *msg, ...) __attribute__((format(printf,1,2)));

/*
 *  SHA1 conversion helpers.
 */
char    *fill_sha1_path  (char *path, const uint8_t *sha1);
char    *format_sha1_str (char *str,  const uint8_t *sha1);
uint8_t *string_to_sha1  (uint8_t *sha1, const char *str);

/*
 *  Unicode <-> local codepage reencoding.
 */
size_t loc2utf (const char *from, const void *to,
                const char *loc, size_t loc_len,
                char *utf, size_t utf_len);

size_t utf2loc (const char *codepage,
                const char *utf, size_t utf_len,
                char *loc, size_t loc_len);

#endif /* UTILS_H_INCLUDED */
